package com.yeejoin.amos.boot.module.tzs.biz.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.SystemClock;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.common.collect.Maps;
import com.yeejoin.amos.boot.biz.common.bo.ReginParams;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import com.yeejoin.amos.boot.biz.common.utils.DateUtils;
import com.yeejoin.amos.boot.biz.common.utils.NameUtils;
import com.yeejoin.amos.boot.biz.common.utils.RedisUtils;
import com.yeejoin.amos.boot.module.common.api.excel.ExcelUtil;
import com.yeejoin.amos.boot.module.tzs.api.dto.AlarmStatisticsDto;
import com.yeejoin.amos.boot.module.tzs.api.dto.AlertCallInfoDto;
import com.yeejoin.amos.boot.module.tzs.api.dto.AlertCalledDto;
import com.yeejoin.amos.boot.module.tzs.api.dto.AlertCalledObjsDto;
import com.yeejoin.amos.boot.module.tzs.api.dto.AlertCalledQueryDto;
import com.yeejoin.amos.boot.module.tzs.api.dto.ESAlertCalledDto;
import com.yeejoin.amos.boot.module.tzs.api.dto.ESAlertCalledRequestDto;
import com.yeejoin.amos.boot.module.tzs.api.entity.AlertCalled;
import com.yeejoin.amos.boot.module.tzs.biz.service.impl.AlertCalledServiceImpl;
import com.yeejoin.amos.boot.module.tzs.biz.service.impl.AlertFormValueServiceImpl;
import com.yeejoin.amos.boot.module.tzs.biz.service.impl.DispatchPaperServiceImpl;
import com.yeejoin.amos.boot.module.tzs.biz.service.impl.ESAlertCalledService;
import com.yeejoin.amos.boot.module.tzs.biz.utils.AlertBeanDtoVoUtils;
import com.yeejoin.amos.boot.module.tzs.biz.utils.BeanDtoVoUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.typroject.tyboot.core.foundation.enumeration.UserType;
import org.typroject.tyboot.core.foundation.utils.ValidationUtil;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.restful.exception.instance.BadRequest;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;

import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.Field;
import java.text.ParseException;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Stream;

/**
 * 警情接警填报记录
 *
 * @author litw
 * @date 2021-08-03
 */
@RestController
@Api(tags = "警情接警填报记录Api")
@RequestMapping(value = "/alert-called")
public class AlertCalledController extends BaseController {

	@Autowired
	RedisUtils redisUtils;
	@Autowired
	AlertCalledServiceImpl iAlertCalledService;
	@Autowired
	private ESAlertCalledService eSAlertCalledService;
	@Autowired
	DispatchPaperServiceImpl dispatchPaperServiceImpl;
	@Autowired
	AlertFormValueServiceImpl iAlertFormValueService;
    /**
     * 新增警情接警填报记录
     *
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/save")
	@ApiOperation(httpMethod = "POST", value = "新增警情接警填报记录", notes = "新增警情接警填报记录")
	public ResponseModel<AlertCalledDto> save(@RequestBody AlertCalledObjsDto alertCalledObjsDto) {
		if (ValidationUtil.isEmpty(alertCalledObjsDto)
				|| ValidationUtil.isEmpty(alertCalledObjsDto.getAlertCalledDto())){
			throw new BadRequest("参数校验失败.");
		}
		ReginParams reginParams =getSelectedOrgInfo();
		alertCalledObjsDto =iAlertCalledService.createAlertCalled(alertCalledObjsDto,reginParams.getUserModel());
		return ResponseHelper.buildResponse(alertCalledObjsDto.getAlertCalledDto());
	}


	/**
	 *
	 * <pre>
	 * 相似警情分页查询
	 * </pre>
	 *
	 * @param
	 * @param current
	 * @param size
	 * @return
	 * @throws Exception
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY, needAuth = false)
	@ApiOperation(value = "相似警情分页查询")
	@PostMapping(value = "/page/similar")
	public ResponseModel<Page<ESAlertCalledDto>> pageBySimilar(
			@RequestBody ESAlertCalledRequestDto alertCalledVo,
			@RequestParam(value = "current") int current,
			@RequestParam(value = "size") int size) throws Exception {

		Page<ESAlertCalledDto> esAlertCalledDtoPage = eSAlertCalledService.queryByKeys(alertCalledVo, current, size);
		return ResponseHelper.buildResponse(esAlertCalledDtoPage);
	}



    /**
     * 根据id查询
     *
	 * @param id  主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/{id}")
	@ApiOperation(httpMethod = "GET",value = "根据id查询单个警情接警填报记录",  notes = "根据id查询单个警情接警填报记录")
	public ResponseModel<Object> selectOne(@PathVariable Long id) {
		return ResponseHelper.buildResponse(iAlertCalledService.selectAlertCalledById(id));
	}

	/**
	 * 生成工单编号报警人及报警时间
	 *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/getWorkOderNumber")
	@ApiOperation(httpMethod = "GET",value = "生成工单编号报警人及报警时间",  notes = "生成工单编号报警人及报警时间")
	public ResponseModel<AlertCallInfoDto> selectOne() throws ParseException {
		String workOrderNumber = nextId();
        AlertCallInfoDto alertCallInfoDto = new AlertCallInfoDto();
        alertCallInfoDto.setCallTime(DateUtils.stampToDate(System.currentTimeMillis(),"yyyy-MM-dd HH:mm:ss "));
        alertCallInfoDto.setWorkOrderNumber(workOrderNumber);
        alertCallInfoDto.setRecUserId(getUserInfo().getUserId());
        alertCallInfoDto.setRecUserName(getUserInfo().getRealName());
		return ResponseHelper.buildResponse(alertCallInfoDto);
	}


	/**
	 * 获取下一个 工单编号
	 *
	 * @return 下一个 工单编号
	 */
	public synchronized String nextId() throws ParseException {

		String number =  DateUtils.stampToDate(SystemClock.now(),"yyyy-MM-dd HH:mm:ss SSS");
		String newNumber =   number.replace("-","").replace(" ","").replace(":","");
		ReginParams reginParams =getSelectedOrgInfo();
//		Map<String, Object> map =    iAlertCalledService.getAlertInfoList(DateUtils.dateFormat(new Date(),"")+" 00:00:00",
//				DateUtils.dateFormat(new Date(),"")+" 23:59:59",reginParams.getCompany().getOrgCode(),
//				reginParams.getUserModel().getUserId());
				Map<String, Object> map =    iAlertCalledService.getAlertInfoList(DateUtils.stampToDate(System.currentTimeMillis(),"yyyy-MM-dd")+" 00:00:00",
				DateUtils.stampToDate(System.currentTimeMillis(),"yyyy-MM-dd")+" 23:59:59",null,
				null);
		StringBuilder stringBuilder = new StringBuilder();
		stringBuilder.append(newNumber);
		String workOrderNumber = stringBuilder.append(map.get("calledCount") == null  ? "1" : String.valueOf(Integer.parseInt(map.get("calledCount").toString()) + 1)).toString() ;
		return workOrderNumber;
	}

	/**
	 * 警情统计
	 *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/alertStatistics")
	@ApiOperation(httpMethod = "GET",value = "警情统计",  notes = "警情统计")
	public ResponseModel<AlarmStatisticsDto> alertStatistics() throws ParseException {
		ReginParams reginParams =getSelectedOrgInfo();

		//我的待办数量
		QueryWrapper<AlertCalled> todoNumQueryWrapper = new QueryWrapper<>();
		//全部待办数量
		QueryWrapper<AlertCalled> allNumQueryWrapper = new QueryWrapper<>();

		AlarmStatisticsDto alarmStatisticsDto = new AlarmStatisticsDto();
		todoNumQueryWrapper.eq("alert_status",false);
        allNumQueryWrapper.eq("alert_status",false);
		if(null != reginParams) {
			todoNumQueryWrapper.eq("rec_user_id",reginParams.getUserModel().getUserId());
			todoNumQueryWrapper.or(true);
			todoNumQueryWrapper.eq("org_code",reginParams.getCompany().getOrgCode());

            alarmStatisticsDto.setTodoNum(iAlertCalledService.list(todoNumQueryWrapper).size());
            alarmStatisticsDto.setAllNum(iAlertCalledService.list(allNumQueryWrapper).size());


			Map<String, Object> map =    iAlertCalledService.getAlertInfoList(DateUtils.stampToDate(System.currentTimeMillis(),"yyyy-MM-dd")+" 00:00:00",
					DateUtils.stampToDate(System.currentTimeMillis(),"yyyy-MM-dd")+" 23:59:59",null,
					getUserInfo().getUserId());

            // 当天接警
            alarmStatisticsDto.setTodayAlarmNum(map.get("calledCount") == null  ? 0 : Integer.valueOf(map.get("calledCount").toString()))   ;
            //当天提交
            alarmStatisticsDto.setSubmitNum(map.get("majorAlertCount") == null  ? 0 : Integer.valueOf(map.get("majorAlertCount").toString()))   ;
            //投诉咨询数量
            alarmStatisticsDto.setSuggestions(map.get("suggestionsCount") == null  ? 0 : Integer.valueOf(map.get("suggestionsCount").toString()))   ;
            //故障维修数量
            alarmStatisticsDto.setFaultRescue(map.get("faultRescueCount") == null  ? 0 : Integer.valueOf(map.get("faultRescueCount").toString()))   ;
            //困人救援数量
            alarmStatisticsDto.setSleepyIncident(map.get("sleepyIncidentCount") == null  ? 0 : Integer.valueOf(map.get("sleepyIncidentCount").toString()))   ;

            Map<String,Integer> recordMap = Maps.newHashMap();
            // 近七天办理数量
            for(int i = 1 ; i < 8; i++) {
				Map<String, Object> nearlySevenDaysMap =    iAlertCalledService.getAlertInfoList(DateUtils.stampToDate(DateUtils.dateAddDays(new Date(), -i).getTime(),"yyyy-MM-dd")+" 00:00:00",
						DateUtils.stampToDate(DateUtils.dateAddDays(new Date(), -i).getTime(),"yyyy-MM-dd")+" 23:59:59",null,
						getUserInfo().getUserId());
                recordMap.put(DateUtils.stampToDate(DateUtils.dateAddDays(new Date(), -i).getTime(),"yyyy-MM-dd"),nearlySevenDaysMap.get("calledCount") == null  ? 0 : Integer.valueOf(nearlySevenDaysMap.get("calledCount").toString()));
            }
            alarmStatisticsDto.setNearlySevenDaysNum(recordMap);
		}
		return ResponseHelper.buildResponse(alarmStatisticsDto);
	}

	/**
     * 列表分页查询
     *
     * @param pageNum 当前页
     * @param pageSize 每页大小
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/list")
	@ApiOperation(httpMethod = "GET",value = "警情接警填报记录分页查询",  notes = "警情接警填报记录分页查询")
	public ResponseModel<IPage<AlertCalledDto>> queryForPage(String pageNum, String pageSize,String sort, AlertCalledDto alertCalledDto)  {
		AlertCalled alertCalled = BeanDtoVoUtils.convert(alertCalledDto,AlertCalled.class);
		Page<AlertCalled> pageBean;
		IPage<AlertCalled> page;
		QueryWrapper<AlertCalled> alertCalledQueryWrapper = new QueryWrapper<>();

		setQueryWrapper(alertCalledQueryWrapper, alertCalled,sort);

		if (StringUtils.isBlank(pageNum) || StringUtils.isBlank(pageSize)) {
			pageBean = new Page<>(0, Long.MAX_VALUE);
		} else {
			pageBean = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
		}
		page = iAlertCalledService.page(pageBean, alertCalledQueryWrapper);
	    IPage<AlertCalledDto> calledVoIPage = AlertBeanDtoVoUtils.alertCalledIPageDto(page);
		calledVoIPage.getRecords().stream().forEach(e->{
			e.setAlertAddress(e.getCity()+e.getDistrict());
		});
		return ResponseHelper.buildResponse(calledVoIPage);
	}

	private QueryWrapper<AlertCalled> setQueryWrapper(QueryWrapper<AlertCalled> queryWrapper, AlertCalled alertCalled,String sort){
		Class<? extends AlertCalled> aClass = alertCalled.getClass();
		queryWrapper.eq("is_delete", 0);

		if(sort!=null) {
//			String[] date=  sort.split(",");
//			if(date[1].equals("ascend")) {
//				queryWrapper.orderByAsc(RedisKey.humpToLine(date[0]));
//			}else {
//				queryWrapper.orderByDesc(RedisKey.humpToLine(date[0]));
//			}
		}else {
			queryWrapper.orderByDesc("call_time");
		}

		if (alertCalled.getCallTimeStart() != null && alertCalled.getCallTimeEnd() != null) {
			queryWrapper.between("call_time", alertCalled.getCallTimeStart(), alertCalled.getCallTimeEnd());
		}
		if (alertCalled.getIsFatherAlert()) { // 0：接警；1：处警
			queryWrapper.isNull("father_alert");
		}

		Stream<Field> fieldStream = Arrays.stream(aClass.getDeclaredFields()).filter(field -> {
			String name = NameUtils.camel2Underline(field.getName());
			return !("IS_FATHER_ALERT".equals(name));
		});
		fieldStream.forEach(field -> {
			try {
				field.setAccessible(true);
				Object o = field.get(alertCalled);
				if (o != null && !"serialVersionUID".equals(field.getName())) {
					Class<?> type = field.getType();
					String name = NameUtils.camel2Underline(field.getName());
					if (type.equals(Integer.class)) {
						Integer fileValue = (Integer) field.get(alertCalled);
						queryWrapper.eq(name, fileValue);
					} else if (type.equals(String.class)) {
						String fileValue = (String) field.get(alertCalled);
						queryWrapper.eq(name, fileValue);
					} else if (type.equals(Boolean.class)) {
						Boolean fileValue = (Boolean) field.get(alertCalled);
						queryWrapper.eq(name, fileValue);
					}else if (type.equals(Long.class) || "long".equals(type.toString())) {
						Long fileValue = (Long) field.get(alertCalled);
						queryWrapper.eq(name, fileValue);
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
				throw new RuntimeException("系统异常");
			}
		});
		return queryWrapper;
	}



	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(value = "查询警情事件记录", notes = "查询警情事件记录")
	@PostMapping("/selectRecord")
	public ResponseModel<Page<AlertCalledQueryDto>> queryAlertCalledByPager(@RequestBody AlertCalledQueryDto alertCalledQueryDto) {
		List<AlertCalledQueryDto> list = iAlertCalledService.queryAlertListByQueryDto(alertCalledQueryDto);
		Page<AlertCalledQueryDto> result = new Page<AlertCalledQueryDto>(alertCalledQueryDto.getPageNum(), alertCalledQueryDto.getPageSize());
		long totle = list.size();
		result.setRecords(list);
		result.setTotal(totle);
		return ResponseHelper.buildResponse(result);
	}

	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(value = "导出警情事件记录", notes = "导出警情事件记录")
	@PostMapping("/exportSelectRecord")
	public void exportAlertCalled(@RequestBody AlertCalledQueryDto alertCalledQueryDto, HttpServletResponse response) {
		List<AlertCalledQueryDto> list = iAlertCalledService.queryAlertListByQueryDto(alertCalledQueryDto);
		String fileName = "警情事件记录" + System.currentTimeMillis();
		ExcelUtil.createTemplate(response, fileName, "警情事件记录", list,
				AlertCalledQueryDto.class, null, false);
	}


	/**
	 * 冻结工单-维修
	 * @param forzenResult
	 * @param alertId
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/saveForzen")
	@ApiOperation(httpMethod = "POST", value = "冻结工单-维修", notes = "冻结工单-维修")
	public ResponseModel<Boolean> forzenAlertById(@ApiParam(value = "冻结原因", required = true) @RequestParam String forzenResult, @ApiParam(value = "警情id", required = true) @RequestParam Long alertId) {
		if (ValidationUtil.isEmpty(alertId)
				|| ValidationUtil.isEmpty(forzenResult)){
			throw new BadRequest("参数校验失败.");
		}
		LambdaUpdateWrapper<AlertCalled> updateWrapper = new LambdaUpdateWrapper<>();
		updateWrapper.set(AlertCalled::getForzenResult,forzenResult);
		updateWrapper.set(AlertCalled::getAlertStage,1);
		updateWrapper.eq(AlertCalled::getSequenceNbr,alertId);
		return ResponseHelper.buildResponse(iAlertCalledService.update(updateWrapper));
	}

	/**
	 * 工单结案-投诉
	 * @param finalReason
	 * @param alertId
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/saveFinalReason")
	@ApiOperation(httpMethod = "POST", value = "工单结案-投诉", notes = "工单结案-投诉")
	public ResponseModel<Boolean> finishAlertById(@ApiParam(value = "结案说明", required = true) @RequestParam String finalReason, @ApiParam(value = "警情id", required = true) @RequestParam Long alertId) {
		if (ValidationUtil.isEmpty(finalReason)
				|| ValidationUtil.isEmpty(alertId)){
			throw new BadRequest("参数校验失败.");
		}
		LambdaUpdateWrapper<AlertCalled> updateWrapper = new LambdaUpdateWrapper<>();
		updateWrapper.set(AlertCalled::getFinalReason,finalReason);
		updateWrapper.set(AlertCalled::getAlertStage,1);
		updateWrapper.eq(AlertCalled::getSequenceNbr,alertId);
		return ResponseHelper.buildResponse(iAlertCalledService.update(updateWrapper));
	}

}
